#!/usr/bin/wish
# the next line restarts using wish\
exec wish "$0" "$@"

#   TkWhiteboard : a simple network whiteboard completely cross-plateform.
#   version 0.2
#
#   author : Jean-Yves Chasle
#   Copyright (C) Jean-Yves Chasle 2001-2002
#	modifs jean-louis sendral jlsendral@free.fr
#   mail : jeanyves.chasle@free.fr
# 
#   TkWhiteboard is distributed under the GNU General Public Licence.
#   TkWhiteboard comes with ABSOLUTELY NO WARRANTY or GUARANTEE OF FITNESS
#   FOR A PARTICULAR PURPOSE.  See the file COPYING for complete
#   information.
#	Ajout de fonctionnalits (copier, dplacer,...)
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************

global DOSSIER_DESSINS
set DOSSIER_DESSINS $env(HOME)
set nom_elev $env(USER)
#----------------------------------------------------------------------------------------------------------
# wbInitialization (must be called after wbCreateWidgets)
#----------------------------------------------------------------------------------------------------------
proc wbInitialization { } {
	global wb fbcpt

	set wb(generalinfo) { Cliquer sur "Crer le serveur" pour engendrer un nouveau dialogue, ou "Connecter au serveur" pour entrer dans un nouveau dialogue.}
	set wb(servip)	127.0.0.1	;# Default server ip address.
	set wb(servport)	33000		;# Default server port.
	set wb(servpass)	""		;# No default password.
	set wb(timeout)	30000		;# Equivalent to 30 seconds.

	# Server and client messages.
	set wb(msg_askpasswd)	"Server waiting for password..."
	set wb(msg_serverok)	"Server OK, waiting for commands..."
	set wb(msg_clientok)	"Client OK, waiting for feedback..."
	set wb(msg_fbcompleted)	"Feedback completed."

	# Connection status messages.
	set wb(status_disconnected)			"dconnect"
	set wb(status_connectioninprogress)		"connection en cours"
	set wb(status_authenticationinprogress)	"authentification en cours"
	set wb(status_feedbackinprogress)		"retour en cours"
	set wb(status_initsessioncompleted)		"initialisation  complte"

	# Connection variables.
	set wb(mysock) ""
	set wb(connected) 0
	set wb(insession) 0
	set wb(connectionstatus) $wb(status_disconnected)
	set wb(servsock) ""
	set wb(servrunning) 0
	set fbcpt -1	;# Feedback counter (number of the last canvas object).

	# Gid variables.
	wbSetPenStyle "line"
	wbSetPenColor black
	wbSetPenWidth 1
	set wb(button-down) 0
	set wb(colorenable)	black
	set wb(colordisable)	grey50
	set wb(colorhilight)	red
}

#----------------------------------------------------------------------------------------------------------
# wbCreateWidgets
#----------------------------------------------------------------------------------------------------------
proc wbCreateWidgets { } {
	global wb tcl_platform

	# Initialize button images
	set wb(curdir) [pwd]
	image create photo wb(img_free)	-file [file join $wb(curdir) images "free.gif"]
	image create photo wb(img_line)	-file [file join $wb(curdir) images "line.gif"]
	image create photo wb(img_arrow)	-file [file join $wb(curdir) images "arrow.gif"]
	image create photo wb(img_rectempt)	-file [file join $wb(curdir) images "rect.gif"]
	image create photo wb(img_rectfill)	-file [file join $wb(curdir) images "rectfill.gif"]
	image create photo wb(img_elpsempt)	-file [file join $wb(curdir) images "ellipse.gif"]
	image create photo wb(img_elpsfill)	-file [file join $wb(curdir) images "ellipfill.gif"]
	image create photo wb(img_wid1)	-file [file join $wb(curdir) images "width1.gif"]
	image create photo wb(img_wid2)	-file [file join $wb(curdir) images "width2.gif"]
	image create photo wb(img_wid4)	-file [file join $wb(curdir) images "width4.gif"]
	image create photo wb(img_wid8)	-file [file join $wb(curdir) images "width8.gif"]
     image create photo wb(img_wid16)	-file [file join $wb(curdir) images "efftout.gif"]
	image create photo wb(img_wid32)	-file [file join $wb(curdir) images "effun.gif"]
##modif
##  image create photo wb(img_wid16)	-file [file join $wb(curdir) images "effsel.gif"]
##	image create photo wb(img_wid32)	-file [file join $wb(curdir) images "effun.gif"]
image create photo wb(img_wid64)	-file [file join $wb(curdir) images "depl.gif"]
image create photo wb(img_wid128)	-file [file join $wb(curdir) images "defo.gif"]
image create photo wb(img_wid256)	-file [file join $wb(curdir) images "effsel.gif"]
image create photo wb(img_wid512)	-file [file join $wb(curdir) images "ins_txt.gif"]
image create photo wb(img_wid1024)	-file [file join $wb(curdir) images "cop.gif"]
image create photo wb(img_wid2048)	-file [file join $wb(curdir) images "ccoul.gif"]

	# Frames
	frame .fu -bd 2 -relief groove
	frame .fl -bd 2 -relief groove
	frame .fr -bd 2 -relief groove
	frame .fd -bd 2 -relief groove

	grid .fu -row 0 -column 0 -columnspan 2 -sticky ew
	grid .fl -row 1 -column 0 -sticky ns
	grid .fr -row 1 -column 1 -sticky news
	grid .fd -row 2 -column 0 -columnspan 2 -sticky ew

	grid rowconfigure . 0 -weight 0
	grid rowconfigure . 1 -weight 1
	grid rowconfigure . 2 -weight 0
	grid columnconfigure . 0 -weight 0
	grid columnconfigure . 1 -weight 1

	# Inside upper frame
	set wb(btn_client,w) [button .fu.b1 -text "Se connecter au  serveur" -width 20 -command {if $wb(connected) wbCloseClient else wbOpenClient}]
	set wb(btn_server,w) [button .fu.b2 -text "Crer le serveur" -width 20 -command {if $wb(servrunning) wbCloseServer else wbOpenServer}]
	set wb(lbl_ip,w) [label .fu.l1 -text "Serveur: IP"]
	set wb(ent_ip,w) [entry .fu.e1 -textvariable wb(servip) -width 15 -relief sunken]
	set wb(lbl_port,w) [label .fu.l2 -text "Port" -fg black]
	set wb(ent_port,w) [entry .fu.e2 -textvariable wb(servport) -width 5 -relief sunken]
	set wb(lbl_pass,w) [label .fu.l3 -text "Mot de passe"]
	set wb(ent_pass,w) [entry .fu.e3 -textvariable wb(servpass) -width 8 -show "*" -relief sunken]
	set wb(btn_quit,w) [button .fu.b3 -text "Quitter" -command "exit"]

	grid 	$wb(btn_client,w) \
		$wb(btn_server,w) \
		$wb(lbl_ip,w) \
		$wb(ent_ip,w) \
		$wb(lbl_port,w) \
		$wb(ent_port,w) \
		$wb(lbl_pass,w) \
		$wb(ent_pass,w) \
		$wb(btn_quit,w)

	# Inside left frame
		# Sub-frames
		frame .fl.sf1 -bd 2 -relief groove
		frame .fl.sf2 -bd 2 -relief groove
		frame .fl.sf3 -bd 2 -relief groove
	    frame .fl.sf4 -bd 2 -relief groove
        frame .fl.sf5 -bd 2 -relief groove
###modif
		pack .fl.sf1 .fl.sf2 .fl.sf3 .fl.sf4 .fl.sf5 -side top -padx 2 -pady 2

		# Sub_frame "pen style" : buttons
		set wb(chk_free,w) [checkbutton .fl.sf1.b00 -image wb(img_free) -indicatoron 0 -variable wb(chk_free,s) -command {wbSetPenStyle "free"}]
		$wb(chk_free,w) configure -state disabled
		set wb(chk_line,w) [checkbutton .fl.sf1.b10 -image wb(img_line) -indicatoron 0 -variable wb(chk_line,s) -command {wbSetPenStyle "line"}]
		set wb(chk_arrow,w) [checkbutton .fl.sf1.b11 -image wb(img_arrow) -indicatoron 0 -variable wb(chk_arrow,s) -command {wbSetPenStyle "arrow"}]
		set wb(chk_rectempt,w) [checkbutton .fl.sf1.b20 -image wb(img_rectempt) -indicatoron 0 -variable wb(chk_rectempt,s) -command {wbSetPenStyle "rectempt"}]
		set wb(chk_rectfill,w) [checkbutton .fl.sf1.b21 -image wb(img_rectfill) -indicatoron 0 -variable wb(chk_rectfill,s) -command {wbSetPenStyle "rectfill"}]
		set wb(chk_elpsempt,w) [checkbutton .fl.sf1.b30 -image wb(img_elpsempt) -indicatoron 0 -variable wb(chk_elpsempt,s) -command {wbSetPenStyle "elpsempt"}]
		set wb(chk_elpsfill,w) [checkbutton .fl.sf1.b31 -image wb(img_elpsfill) -indicatoron 0 -variable wb(chk_elpsfill,s) -command {wbSetPenStyle "elpsfill"}]

		grid $wb(chk_free,w)
		grid $wb(chk_line,w) $wb(chk_arrow,w)
		grid $wb(chk_rectempt,w) $wb(chk_rectfill,w)
		grid $wb(chk_elpsempt,w) $wb(chk_elpsfill,w)

		# Sub_frame "pen color" : button
		set wb(btn_color,w) [button .fl.sf2.b0 -bg black -width 4 -command {wbSetPenColor}]

		pack $wb(btn_color,w) -fill both -expand yes -ipadx 2 -ipady 2

		# Sub_frame "pen width" : buttons
		set wb(chk_wid1,w) [checkbutton .fl.sf3.b00 -image wb(img_wid1) -indicatoron 0 -variable wb(chk_wid1,s) -command {wbSetPenWidth 1}]
		set wb(chk_wid2,w) [checkbutton .fl.sf3.b01 -image wb(img_wid2) -indicatoron 0 -variable wb(chk_wid2,s) -command {wbSetPenWidth 2}]
		set wb(chk_wid4,w) [checkbutton .fl.sf3.b10 -image wb(img_wid4) -indicatoron 0 -variable wb(chk_wid4,s) -command {wbSetPenWidth 4}]
		set wb(chk_wid8,w) [checkbutton .fl.sf3.b11 -image wb(img_wid8) -indicatoron 0 -variable wb(chk_wid8,s) -command {wbSetPenWidth 8}]

		grid $wb(chk_wid1,w) $wb(chk_wid2,w)
		grid $wb(chk_wid4,w) $wb(chk_wid8,w)
## Utilitaires pour effacer tout, un.
## Dplacer, agrandir, imprimer
		set wb(chk_del16,w) [checkbutton .fl.sf4.b00 -image wb(img_wid16) -indicatoron 0 -variable wb(chk_del,s) -command {wbSetPenStyle del ; wbSetDel tout}]
set wb(chk_del32,w) [checkbutton .fl.sf4.b01 -image wb(img_wid32) -indicatoron 0 -variable wb(chk_sel,s) \
-command {wbSetPenStyle sel  ; wbSetDel sel }]
set wb(chk_dep64,w) [checkbutton .fl.sf4.b10 -image wb(img_wid64) -indicatoron 0 -variable wb(chk_dep,s) \
-command {wbSetPenStyle dep }]
set wb(chk_dep128,w) [checkbutton .fl.sf4.b11 -image wb(img_wid128) -indicatoron 0 \
-variable wb(chk_agg,s) -command {wbSetPenStyle agg }]
set wb(chk_dep256,w) [checkbutton .fl.sf4.b100 -image wb(img_wid256) -indicatoron 0 \
-variable wb(chk_del_sel,s) -command {wbSetPenStyle del_sel }]
set wb(chk_dep512,w) [checkbutton .fl.sf4.b101 -image wb(img_wid512) -indicatoron 0 \
-variable wb(chk_ins_txt,s) -command {wbSetPenStyle ins_txt }]
set wb(chk_dep1024,w) [checkbutton .fl.sf4.b102 -image wb(img_wid1024) -indicatoron 0 \
-variable wb(chk_copie,s) -command {wbSetPenStyle copie }]
set wb(chk_dep2048,w) [checkbutton .fl.sf4.b110 -image wb(img_wid2048) -indicatoron 0 \
-variable wb(chk_ccoul,s) -command {wbSetPenStyle ccoul }]


###wbSetDel sel 


		grid $wb(chk_del16,w)
		grid $wb(chk_del32,w)
		grid $wb(chk_dep256,w) 
        grid $wb(chk_dep64,w) 
 		grid $wb(chk_dep1024,w)
        grid $wb(chk_dep128,w)
		grid $wb(chk_dep2048,w)
        grid $wb(chk_dep512,w)


label .fl.sf4.txt -text "Texte : "
grid  .fl.sf4.txt
entry .fl.sf4.input_txt -textvariable input_txt -relief sunken -width 10
grid .fl.sf4.input_txt
button .fl.sf4.aide  -text Sauver(ps) -command " sauver_ps "
grid .fl.sf4.aide      		
	# Inside right frame
	set wb(canvas,w) [canvas .fr.canvas -bg white  -height 460 -width 600]
 
 if { $tcl_platform(platform) == "unix" } {
  button .fl.sf4.impr  -text Impr -command " imprime   $wb(canvas,w)"
    grid .fl.sf4.impr 
}
	bind $wb(canvas,w) <Button-1> {button-down %x %y}
	bind $wb(canvas,w) <B1-Motion> {button-motion %x %y}
	bind $wb(canvas,w) <ButtonRelease-1> {button-release %x %y}
    bind $wb(canvas,w) <Shift-ButtonRelease-1> {button-release_shift %x %y}

	pack $wb(canvas,w) -fill both -expand yes 
	# Inside lower frame
	set wb(lbl_geninfo,w) [label .fd.l1 -textvariable wb(generalinfo) -fg black]
	pack $wb(lbl_geninfo,w) -fill both -expand yes

	wbInitialization
}

#----------------------------------------------------------------------------------------------------------
# wbSetPenStyle : proc linked to the "pen style" checkbuttons.
#----------------------------------------------------------------------------------------------------------
proc wbSetPenStyle { style } {
	global wb

	set chk_name [format "%s%s" "chk_" $style]
	set wb([format "%s%s%s" "chk_" $style ",s"]) 1
	set wb(curstyle) $style

	if {$style != "free"} {set wb(chk_free,s) 0}
	if {$style != "line"} {set wb(chk_line,s) 0}
	if {$style != "arrow"} {set wb(chk_arrow,s) 0}
	if {$style != "rectempt"} {set wb(chk_rectempt,s) 0}
	if {$style != "rectfill"} {set wb(chk_rectfill,s) 0}
	if {$style != "elpsempt"} {set wb(chk_elpsempt,s) 0}
	if {$style != "elpsfill"} {set wb(chk_elpsfill,s) 0}
##modif
    if {$style != "del"} {set wb(chk_del,s) 0 }
   if {$style != "sel"} {set wb(chk_sel,s) 0}
if {$style != "dep"} {set wb(chk_width64,s) 0 }
   if {$style != "agg"} {set wb(chk_agg,s) 0}
if {$style != "del_sel"} {set wb(chk_del_sel,s) 0}
if {$style != "ins_txt"} {set wb(chk_ins_txt,s) 0}
if {$style != "copie"} {set wb(chk_copie,s) 0}
if {$style != "ccoul"} {set wb(chk_ccoul,s) 0}

}

#----------------------------------------------------------------------------------------------------------
# wbSetPenColor : proc linked to the "pen color" button.
#----------------------------------------------------------------------------------------------------------
proc wbSetPenColor { {color ""} } {
	global wb

	if {$color != ""} {
		set wb(curcolor) $color
		$wb(btn_color,w) config -bg $color
	} else {
		set color [tk_chooseColor -title "Choisir une couleur" -parent . -initialcolor $wb(curcolor)]
		if [string compare $color ""] {
			set wb(curcolor) $color
			$wb(btn_color,w) config -bg $color
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbSetPenWidth : proc linked to the "pen width" checkbuttons.
#----------------------------------------------------------------------------------------------------------
proc wbSetPenWidth { width } {
	global wb

	set wb([format "%s%s%s" "chk_wid" $width ",s"]) 1
	set wb(curwidth) $width

	if {$width != 1} {set wb(chk_wid1,s) 0}
	if {$width != 2} {set wb(chk_wid2,s) 0}
	if {$width != 4} {set wb(chk_wid4,s) 0}
	if {$width != 8} {set wb(chk_wid8,s) 0}
}

#----------------------------------------------------------------------------------------------------------
# wbOpenServer : proc linked to the "create server" button.
#----------------------------------------------------------------------------------------------------------
proc wbOpenServer { } {
	global wb

	# Open the server socket.
	catch {close $wb(servsock)}
	if [catch {socket -server wbServerOpenNewClientSocket $wb(servport)} wb(servsock)] {
		set wb(generalinfo) "Serveur_socket ne peut tre attach  un  port dj utilis $wb(servport)..."
	} else {
		set wb(servrunning) 1
		set wb(generalinfo) "Serveur connect au port $wb(servport). Attend l'appel d'un client..."

		$wb(btn_server,w) config -text "Fermer le serveur" -foreground $wb(colorhilight)
		$wb(btn_client,w) config -state disabled
		$wb(ent_ip,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_port,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_pass,w) config -state disabled -foreground $wb(colordisable)
	}
}

#----------------------------------------------------------------------------------------------------------
# wbServerOpenNewClientSocket : callback proc called by the listening system.
#----------------------------------------------------------------------------------------------------------
proc wbServerOpenNewClientSocket {sock ip port} {
	global wb guest

	# This function is called when the server receives a connection.
	set guest($sock) [list $wb(status_authenticationinprogress) $ip $port]
	set wb(connected) 1
#	fconfigure $sock -buffering line

	# "Receive character line from guest or client" callback.
	fileevent $sock readable [list wbServerReadGuestLineFromBuffer $sock]

	# Ask new guest for a password.
	puts $sock $wb(msg_askpasswd)
	flush $sock
	set wb(generalinfo) "Un nouveau client  ([lindex $guest($sock) 1]) est connect au serveur."
}

#----------------------------------------------------------------------------------------------------------
# wbServerReadGuestLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbServerReadGuestLineFromBuffer { sock } {
	global wb guest client fb

	# Read a line when it's completely buffered.
	set numargs [gets $sock line]
 	if {$numargs == -1} {
		catch {close $sock}
		set wb(generalinfo) "Le client  ([lindex $guest($sock) 1])  est dconnect."
		unset guest($sock)

		# Update $wb(connected) after deleting a guest socket.
		if {[array size guest] == 0 && [array size client] == 0} {
			set wb(connected) 0
		}

		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text "Se connecter au serveu" -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "Reois  $line."
		switch [lindex $guest($sock) 0] \
			$wb(status_authenticationinprogress) {
				if {$line == $wb(servpass)} {
					set guest($sock) [lreplace $guest($sock) 0 0 $wb(status_feedbackinprogress)]

					# Send "Ok" message to guest.
					puts $sock $wb(msg_serverok)
					flush $sock
					set wb(generalinfo) "Un nouveau client ([lindex $guest($sock) 0]) rejoins le dialogue. Envoi du retour..."
				} else {
					# Disconnect guest : wrong password.
					catch {close $sock}
					set wb(generalinfo)  "Mauvais mot de passe. Guest ([lindex $guest($sock) 1])  est dconnect par le serveur."
					unset guest($sock)

					# Update $wb(connected) after deleting a guest socket.
					if {[array size guest] == 0 && [array size client] == 0} {
						set wb(connected) 0
					}
				}
			} \
			$wb(status_feedbackinprogress) {
				if {$line == $wb(msg_clientok)} {
					# Send feedback to client.
					set cpt 0
					while {[info exists fb($cpt)]} {
						puts $sock $fb($cpt)
						flush $sock
						incr cpt
					}

					# Send "end of feedback" message to client.
					puts $sock $wb(msg_fbcompleted)
					flush $sock

					# Guest upgrades to client.
					set client($sock) [list [lindex $guest($sock) 1] [lindex $guest($sock) 2]]
					unset guest($sock)
					set wb(insession) 1

					# Change the "receive character line from client" callback.
					fileevent $sock readable [list wbServerReadClientLineFromBuffer $sock]
					set wb(generalinfo) "Client ([lindex $client($sock) 0]) peut dialoguer..."
				}
			} \
			default {
				set wb(generalinfo) "Reois une nouvelle commande : \"$line\" !"
			}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbServerReadClientLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbServerReadClientLineFromBuffer { sock } {
	global wb guest client fbcpt fb

	# Read a line when it's completely buffered.
	set numargs [gets $sock line]
 	if {$numargs == -1} {
		catch {close $sock}
		set wb(generalinfo) "Client ([lindex $client($sock) 0]) est dconnect."
		unset client($sock)

		# Update and $wb(insession) after deleting a guest or client socket.
		if {[array size client] == 0} {
			set wb(insession) 0
			if {[array size guest] == 0} {
				set wb(connected) 0
			}
		}

		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text "Connect to server" -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "Reois $line.";
		wbProcessReceivedCmd $line
		incr fbcpt 1
		set fb($fbcpt) $line
		wbDispatchReceivedCmd $sock $line
	}
}

#----------------------------------------------------------------------------------------------------------
# wbCloseServer : proc linked to the "create server" button.
#----------------------------------------------------------------------------------------------------------
proc wbCloseServer { } {
	global wb guest client

	# Close every socket stored in client array.
	set wb(generalinfo) "Connections se ferment..."
	foreach {sock} [array names guest] {
		fileevent $sock readable {}
		catch {close $sock}
		unset guest($sock)
	}
	foreach {sock} [array names client] {
		fileevent $sock readable {}
		catch {close $sock}
		unset client($sock)
	}
	set wb(connected) 0
	set wb(generalinfo) "Connections fermes."

	# Close the server socket.
	catch {close $wb(servsock)}
	set wb(servrunning) 0
	set wb(generalinfo) "Serveur ferm."
	$wb(btn_server,w) config -text "Crer le serveur" -foreground $wb(colorenable)
	$wb(btn_client,w) config -state normal
	$wb(ent_ip,w) config -state normal -foreground $wb(colorenable) 
	$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
	$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
}

#----------------------------------------------------------------------------------------------------------
# wbOpenClient : proc linked to the "connect to server" button.
#----------------------------------------------------------------------------------------------------------
proc wbOpenClient { } {
	global wb

	# Open the data socket.
	catch {close $wb(mysock)}
	set wb(connected) 0
	set wb(insession) 0
	set wb(connectionstatus) $wb(status_disconnected)
	if {[catch {socket -async $wb(servip) $wb(servport)} wb(mysock)]} {
		set wb(generalinfo) "Aucun socket n'est disponible sur cet ordinateur !"
		return
	}

	# "Receive character line from server" callback.
	fileevent $wb(mysock) readable wbGuestReadServerLineFromBuffer

	set wb(generalinfo) "Essai de  connection au serveur $wb(servip) sur le  port $wb(servport)."
	set wb(connectionstatus) $wb(status_connectioninprogress)
	$wb(btn_client,w) config -state disabled
	$wb(btn_server,w) config -state disabled
	$wb(ent_ip,w) config -state disabled -foreground $wb(colordisable)
	$wb(ent_port,w) config -state disabled -foreground $wb(colordisable)
	$wb(ent_pass,w) config -state disabled -foreground $wb(colordisable)

	# Waiting $timeout milliseconds before declaring that connection failed.
	set afterid [after $wb(timeout) {set wb(connected) 0}]
	vwait wb(connected) ;# Either modified by wbGuestReadLineFromBuffer or timeout.
	after cancel $afterid

	# Connection issue : it may be 1 (successfull) or 0 (timeout).
	if {$wb(connected)} {
		# This code is run after the msg_serverok is received in wbClientReadLineFromBuffer.
		$wb(btn_client,w) config -state normal -text "Fermer la connection " -foreground $wb(colorhilight)
		$wb(ent_ip,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_port,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_pass,w) config -state disabled -foreground $wb(colordisable)
	} else {
		# This code is run after the preceeding "after" command (timeout).
		catch {close $wb(mysock)}
		set wb(connectionstatus) $wb(status_disconnected)
		set wb(generalinfo) "Serveur $wb(servip) sur le  port $wb(servport) ne rpond pas. Echec  la connection."
		$wb(btn_client,w) config -state normal
		$wb(btn_server,w) config -state normal
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	}
}

#----------------------------------------------------------------------------------------------------------
# wbGuestReadServerLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbGuestReadServerLineFromBuffer { } {
	global wb

	# Read a line when it's completely arrived.
	set numargs [gets $wb(mysock) line]
 	if {$numargs == -1} {
		catch {close $wb(mysock)}
		set wb(mysock) ""
		switch $wb(connectionstatus) \
			$wb(status_authenticationinprogress) {
				set wb(generalinfo) "Mot de passe incorrect. Dconnection du serveur."
			} \
			default {
				set wb(generalinfo) "Dconnect par le serveur."
			}
		set wb(connected) 0
		set wb(insession) 0
		set wb(connectionstatus) $wb(status_disconnected)
		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text "Connect to server" -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "[string length $line] [string length $wb(msg_askpasswd)] \"$line\" !"
		switch $line \
			$wb(msg_askpasswd) {
				# Send the password to server.
				puts $wb(mysock) $wb(servpass)
				flush $wb(mysock)

				set wb(connected) 1
				set wb(generalinfo) "Connect au serveur. Envoi du mot de passe.."
				set wb(connectionstatus) $wb(status_authenticationinprogress) \
			} \
			$wb(msg_serverok) {
				# Change the "receive character line from server" callback.
				fileevent $wb(mysock) readable wbClientReadServerLineFromBuffer

				# Send "ok" message to server.
				puts $wb(mysock) $wb(msg_clientok)
				flush $wb(mysock)

				set wb(generalinfo) "Connection  une nouvellle session. Attente du retour.."
				set wb(connectionstatus) wb(status_feedbackinprogress)
			} \
			default {
				set wb(generalinfo) "Rception d'une commande inconnue  : \"$line\" !"
			}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbClientReadServerLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbClientReadServerLineFromBuffer { } {
	global wb

	# Read a line when it's completely arrived.
	set numargs [gets $wb(mysock) line]
 	if {$numargs == -1} {
		catch {close $wb(mysock)}
		set wb(mysock) ""
		set wb(generalinfo) "Dconnect du serveur."
		set wb(connected) 0
		set wb(insession) 0
		set wb(connectionstatus) $wb(status_disconnected)
		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text "Connect to server" -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "Reois $line.";
		if {$line == $wb(msg_fbcompleted)} {
			set wb(insession) 1
			set wb(connectionstatus) $wb(status_initsessioncompleted) 
			set wb(generalinfo) "Feedback complet., on  participe  la session ouverte."
		} else {
			wbProcessReceivedCmd $line
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbCloseClient : proc linked to the "connect to server" button.
#----------------------------------------------------------------------------------------------------------

proc wbCloseClient { } {
	global wb

	# Close the data socket.
	set wb(generalinfo) "Connection se termine.."
	catch {close $wb(mysock)}
	set wb(mysock) ""
	set wb(generalinfo) "Dconnect du serveur."
	set wb(connected) 0
	set wb(insession) 0
	set wb(connectionstatus) $wb(status_disconnected)
	$wb(btn_server,w) config -state normal
	$wb(btn_client,w) config -text "Connect au serveur" -foreground $wb(colorenable)
	$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
	$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
	$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
}

#----------------------------------------------------------------------------------------------------------
# wbSendOwnCmd : proc called from mouse callbacks button-move and button-release.
#----------------------------------------------------------------------------------------------------------
proc wbSendOwnCmd { cmd } {
	global wb client fbcpt fb

	if $wb(insession) {
		if $wb(servrunning) {
			# Server part.
			incr fbcpt 1
			set fb($fbcpt) $cmd

			foreach sock [array names client] {
				puts $sock $cmd
				flush $sock
			}
		} else {
			# Client part.
			puts $wb(mysock) $cmd
			flush $wb(mysock)
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbDispatchReceivedCmd : proc called by wbServerReadlLineFromBuffer.
#----------------------------------------------------------------------------------------------------------
proc wbDispatchReceivedCmd { sendersock cmd } {
	global wb client

	if {$wb(servrunning) && $wb(insession)} {
		foreach sock [array names client] {
			if {$sendersock == $sock} {continue}
			puts $sock $cmd
			flush $sock
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbProcessReceivedCmd : proc called from wbServerReadLineFromBuffer and wbClientReadLineFromBuffer .
#----------------------------------------------------------------------------------------------------------
proc wbProcessReceivedCmd { cmd } {
	global wb
####effacer deplacer ...
	set style [lindex $cmd 0]
	switch $style {
		ccoul -
		del  { eval [lrange $cmd 1 end] }
		sel { eval [lrange $cmd 1 end] }
		dep {eval [lrange $cmd 1 end] }
		agg {eval [lrange $cmd 1 end] }
		del_sel {eval [lrange $cmd 1 end] }
		ins_txt  {eval [lrange $cmd 1 end] }
		copie  { eval [lrange $cmd 1 end] }
		free	-
		line		{$wb(canvas,w) create line		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6]}
		arrow		{$wb(canvas,w) create line		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6] -arrow last}
		rectempt	{$wb(canvas,w) create rectangle	[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -outline [lindex $cmd 6]}
		rectfill	{$wb(canvas,w) create rectangle	[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6]}
		elpsempt	{$wb(canvas,w) create arc		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -outline [lindex $cmd 6] -start 0 -extent 359 -style arc}
		elpsfill	{$wb(canvas,w) create arc		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6] -start 0 -extent 359 -style chord}
		default	{set wb(generalinfo) "Rception d'une commande inconnue :  \"$cmd\""}
	}
}
proc wbSetDel {quoi} { 
global wb
switch $quoi {
	tout { foreach id [ $wb(canvas,w) find all]  {$wb(canvas,w) delete $id  ; wbSendOwnCmd  [list del  $wb(canvas,w) delete $id ] }
}
	sel { }

   }
}
proc inser_txt {text x y} {
global wb
 $wb(canvas,w) create text $x $y -text $text  -anchor sw -font {helvetica 12} -fill $wb(curcolor)

}
proc traite {cur1}  {
global wb cop
switch [ $wb(canvas,w) type $cur1 ] {
	line { 	
	if { [ $wb(canvas,w) itemcget $cur1 -arrow ] != ""  } {
			set cop [concat $wb(canvas,w) create [$wb(canvas,w) type $cur1 ] [$wb(canvas,w) coords $cur1 ] \
   	"\-width [$wb(canvas,w) itemcget $cur1 -width ]" "\-fill [$wb(canvas,w) itemcget $cur1 -fill ]" \
   	"\-arrow [$wb(canvas,w) itemcget $cur1 -arrow ]" ] 
			} else {
		  set cop [concat $wb(canvas,w) create [$wb(canvas,w) type $cur1 ] [$wb(canvas,w) coords $cur1 ] \
			"\-width [$wb(canvas,w) itemcget $cur1 -width ]" "\-fill [$wb(canvas,w) itemcget $cur1 -fill]" ]
			}
	}
	arc {
	if { [ $wb(canvas,w) itemcget $cur1 -fill ] != ""  } {
 set cop [concat $wb(canvas,w) create [$wb(canvas,w) type $cur1 ] [$wb(canvas,w) coords $cur1 ] \
			"\-width [$wb(canvas,w) itemcget $cur1 -width ]" "\-fill [$wb(canvas,w) itemcget $cur1 -fill]" \
			"\-extent 359" "\-start 0" "\-style [$wb(canvas,w) itemcget $cur1 -style]" ]

			} else {
if { [ $wb(canvas,w) itemcget $cur1 -outline ] != ""  } {
 set cop [concat $wb(canvas,w) create [$wb(canvas,w) type $cur1 ] [$wb(canvas,w) coords $cur1 ] \
			"\-width [$wb(canvas,w) itemcget $cur1 -width ]" "\-outline [$wb(canvas,w) itemcget $cur1 -outline]" \
			"\-extent 359" "\-start 0" "\-style [$wb(canvas,w) itemcget $cur1 -style]" ]
  }
}
}
}
}

proc change_coul { obj coul } {
global wb
if { $obj == "" } { return}
   switch  [$wb(canvas,w) type $obj] {
  	arrow -
  	line {
  	$wb(canvas,w) itemconfigure $obj  -fill $coul
  	wbSendOwnCmd  [list ccoul $wb(canvas,w) itemconfigure $obj  -fill $coul]
  	 	}
   	arc -
  	rectangle {
  	if { [ $wb(canvas,w) itemcget $obj -fill ] != ""  } {
	  $wb(canvas,w) itemconfigure $obj  -fill $coul
  	wbSendOwnCmd  [list ccoul $wb(canvas,w) itemconfigure $obj  -fill $coul]
	  	}
  	if { [ $wb(canvas,w) itemcget $obj -outline ] != ""  } {
  	$wb(canvas,w) itemconfigure $obj  -outline $coul
  	wbSendOwnCmd  [list ccoul $wb(canvas,w) itemconfigure $obj  -outline $coul]
	}
  	}
  	text {
   $wb(canvas,w) itemconfigure $obj  -fill $coul
  	wbSendOwnCmd  [list ccoul $wb(canvas,w) itemconfigure $obj  -fill $coul]

	}
	default {
				set wb(generalinfo) "Style inconnu \"$wb(curstyle)\"..."
			}



}
}

#----------------------------------------------------------------------------------------------------------
# button-down : mouse callback linked to the canvas.
#----------------------------------------------------------------------------------------------------------
proc button-down { sx sy } {
	global wb cur cop
	if $wb(insession) {
		set wb(button-down) 1
		switch $wb(curstyle) {
			sel {set cur [$wb(canvas,w) find withtag  current ] ; $wb(canvas,w) delete current ; \
		wbSendOwnCmd  [list sel $wb(canvas,w) delete $cur ]
				}
			del {}
			dep { set wb(lastx) $sx
			   	set wb(lasty) $sy
    			set cur [$wb(canvas,w) find withtag  current ] }

			agg {set wb(lastx) $sx
			   	set wb(lasty) $sy
    			set cur [$wb(canvas,w) find withtag  current ] 
#####  			$wb(canvas,w) scale $cur 0 0  0.8 0.8
####	  wbSendOwnCmd  [list agg $wb(canvas,w) scale $cur 0 0  0.8 0.8 ]

    		}
			del_sel {set cur [$wb(canvas,w) find withtag  current ] ; \
			if { $cur != "" } {
			 set lobj [$wb(canvas,w) find overlapping \
			[lindex [$wb(canvas,w) bbox $cur ] 0] [lindex [$wb(canvas,w) bbox $cur ] 1] \
			[lindex [$wb(canvas,w)  bbox $cur] 2] [lindex [$wb(canvas,w) bbox $cur] 3] ] 
			foreach obj $lobj { 
			 $wb(canvas,w) delete $obj 
			 wbSendOwnCmd  [list del_sel $wb(canvas,w) delete $obj ]
			 				}
			 $wb(canvas,w) delete $cur ;  wbSendOwnCmd  [list del_sel $wb(canvas,w) delete $cur ]
				}
			 	}
			ins_txt {inser_txt [.fl.sf4.input_txt get] $sx $sy ; \
			 wbSendOwnCmd  [list ins_txt  $wb(canvas,w) create text $sx $sy -text [.fl.sf4.input_txt get] \
			  -anchor sw  -font {helvetica 12} -fill $wb(curcolor) ]
			 }

			ccoul { set cur [ $wb(canvas,w) find withtag  current ] ; \
					set n_coul $wb(curcolor)
					change_coul $cur $n_coul
			}
			copie {set cur [$wb(canvas,w) find withtag  current ] ; \
		   if { $cur != "" } {
		   switch  [$wb(canvas,w) type $cur ] {
				rectangle {
			if { [ $wb(canvas,w) itemcget $cur -fill ] != ""  } {
			set cop [concat $wb(canvas,w) create [$wb(canvas,w) type $cur ] [$wb(canvas,w) coords $cur ] \
			"\-width [$wb(canvas,w) itemcget $cur -width ]" "\-outline [$wb(canvas,w) itemcget $cur -outline]" \
			"\-fill [$wb(canvas,w) itemcget $cur -fill]"] 
			} else {
		  set cop [concat $wb(canvas,w) create [$wb(canvas,w) type $cur ] [$wb(canvas,w) coords $cur ] \
			"\-width [$wb(canvas,w) itemcget $cur -width ]" "\-outline [$wb(canvas,w) itemcget $cur -outline]" ]
			 	}
		    }
			
		    line -
		    arc { traite $cur }
		    text {set cop {} }
		    default {
				set wb(generalinfo) "Pas de copie \"$wb(curstyle)\"..."
			}
			}
			  	   }
			set wb(lastx) $sx
				set wb(lasty) $sy
				}			
			free -
			line {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create line $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor)]
			}
			arrow {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create line $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor) -arrow last]
			}
			rectempt {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create rectangle $sx $sy $sx $sy -width $wb(curwidth) -outline $wb(curcolor)]
			}
			rectfill {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create rectangle $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor)]
			}
			elpsempt {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create arc $sx $sy $sx $sy -width $wb(curwidth) -outline $wb(curcolor) -start 0 -extent 359 -style arc]
			}
			elpsfill {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create arc $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor) -start 0 -extent 359 -style chord]
			}
			default {
				set wb(generalinfo) "Style inconnu \"$wb(curstyle)\"..."
			}
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# button-motion : mouse callback linked to the canvas.
#----------------------------------------------------------------------------------------------------------
proc button-motion { nx ny } {
	global wb cur 
			if {$wb(insession) && $wb(button-down)} {
		switch $wb(curstyle) {
			free {
				$wb(canvas,w) create line $wb(lastx) $wb(lasty) $nx $ny -width $wb(curwidth) -fill $wb(curcolor)
				wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty) $nx $ny $wb(curwidth) $wb(curcolor)]
				set wb(lastx) $nx
				set wb(lasty) $ny
			}
			sel {}
			del {}
			dep { $wb(canvas,w) move $cur [expr $nx - $wb(lastx) ] [expr $ny - $wb(lasty) ] ; \
				wbSendOwnCmd [list dep $wb(canvas,w) move $cur [expr $nx -  $wb(lastx)] \
				[expr $ny - $wb(lasty)] ] ;\
		    	set wb(lastx) $nx
				set wb(lasty) $ny
							}
			agg {}		
			del_sel {}
			copie {}
			ccoul {}
			line -
			arrow -
			rectempt -
			rectfill -
			elpsempt -
			elpsfill {
				$wb(canvas,w) coords $wb(lastobj,w) $wb(lastx) $wb(lasty) $nx $ny
			}
			default {
				set wb(generalinfo) "Style inconnu \"$wb(curstyle)\"..."
			}
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# button-release : mouse callback linked to the canvas.
#----------------------------------------------------------------------------------------------------------
proc button-release { nx ny } {
	global wb cur cop

	if {$wb(insession) && $wb(button-down)} {
		set $wb(button-down) 0
		switch $wb(curstyle) {
			free {set wb(curstyle) free }
			del {}
			sel {}
			dep {}
			del_sel {}
			ccoul {}
			ins_txt {}
			agg {
			if { $cur != "" } {
			set factx [expr [expr 1.0 * $nx]  / [lindex [$wb(canvas,w) bbox $cur ] 2 ] ]
		set facty [expr [expr 1.0 * $ny]  / [lindex [$wb(canvas,w) bbox $cur] 3] ]
	 	$wb(canvas,w) scale $cur [lindex [$wb(canvas,w) bbox $cur] 0] \
			 [lindex [$wb(canvas,w) bbox $cur] 1] $factx $facty
			 wbSendOwnCmd  [list agg $wb(canvas,w) scale $cur [lindex [$wb(canvas,w) bbox $cur] 0] \
			 [lindex [$wb(canvas,w) bbox $cur] 1] $factx  $facty ] ; set wb(curstyle) "" 
						}
				}
			copie {
			if { $cur != "" } {
			 eval $cop ;
			$wb(canvas,w) move $cur [expr $nx - $wb(lastx) ] [expr $ny - $wb(lasty) ] 
				wbSendOwnCmd [list copie $wb(canvas,w) move $cur [expr $nx -  $wb(lastx) ] [expr $ny - $wb(lasty)]]
		    	wbSendOwnCmd [list copie eval $cop ]
			}
			}
			line -
			arrow -
			rectempt -
			rectfill -
			elpsempt -
			elpsfill {
				wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty) $nx $ny $wb(curwidth) $wb(curcolor)]
			}
			default {
				set wb(generalinfo) "Style inconnu \"$wb(curstyle)\"..."
			}
		}
	}
}

proc button-release_shift { nx ny } {
global wb env cur cop
	if {$wb(insession) && $wb(button-down)} {
		set $wb(button-down) 0
		switch $wb(curstyle) {
		    free {}
			del {}
			sel {}
			dep {}
			del_sel {}
			ins_txt {}
			agg {}
			copie {}
			line -
			arrow {
			set deltax [expr abs([expr $nx - $wb(lastx)])] 
			set deltay [expr abs([expr $ny - $wb(lasty)])]
			if { $deltay == 0 } { 
			set angle 3 ; set rapp 0.01 } elseif { $deltax == 0 } { 
			set angle 85 ; set rapp 6 } else {
			set rapp [expr 1.0 * $deltay / $deltax] 
			set arc [expr atan($rapp) ] 
			set r1  [expr  180 / 3.14 ] ; set angle [ expr $arc * $r1 ]
			}
##			set r1  [expr  180 / 3.14 ] ; set angle [ expr $arc * $r1 ]
			if { $angle <= 5 } {
			$wb(canvas,w) coords $wb(lastobj,w) $wb(lastx) $wb(lasty) $nx $wb(lasty)
			wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty)  $nx $wb(lasty) $wb(curwidth) $wb(curcolor)]
			} elseif { $angle  > 84 } {
			$wb(canvas,w) coords $wb(lastobj,w) $wb(lastx) $wb(lasty) $wb(lastx) $ny 
			wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty)  $wb(lastx) $ny $wb(curwidth) $wb(curcolor)]
					} else {
					$wb(canvas,w) coords $wb(lastobj,w) $wb(lastx) $wb(lasty) $nx $ny
					wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty)  $nx $ny $wb(curwidth) $wb(curcolor)]

					}
			}
		    rectempt -
			rectfill -
			elpsempt -
			elpsfill {
				set diff [expr int([expr int([expr $nx - $wb(lastx)]) - int([expr $ny - $wb(lasty)])])]
				$wb(canvas,w) coords $wb(lastobj,w) $wb(lastx) $wb(lasty) \
				 $nx   [expr $ny + $diff ] 
     	wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty) $nx  [expr $ny + $diff ] \
     	$wb(curwidth) $wb(curcolor)]
		     	}
          default {
				set wb(generalinfo) "Style inconnu \"$wb(curstyle)\"..."
			}
}
}
}
proc sauver_ps {} {
global basedir DOSSIER_DESSINS nom_elev wb
  set date [clock format [clock seconds] -format "%H%M%d%b"]
cd $DOSSIER_DESSINS
global nom_elev nom_class
$wb(canvas,w)  postscript -file "${nom_elev}$date.ps"
# -height 20c -width 20c  -file "$nom_elev.ps"
##cd $basedir
}

############  tudier pour imprimer sous windows
proc imprime {c} {
if {[info exists env(PRINTER)]} {
    set psCmd "lpr -P$env(PRINTER)"
} else {
    set psCmd "lpr"
}

set postscriptOpts {-pageheight 190m -pagewidth 280m -pageanchor c}

if {[catch {eval exec $psCmd <<    \
		  {[eval $c postscript $postscriptOpts]}} msg]} {
		    tk_messageBox -message  \
		      "Error when printing: $msg" -icon error -type ok
		}
}

#----------------------------------------------------------------------------------------------------------
# wbMain : main proc.
#----------------------------------------------------------------------------------------------------------
proc wbMain { } {
##	wm minsize . 30 5
	wm title . "TkWhiteboard 0.2  modifi(sous GPL)"
##	wm geometry . +0+0
   . configure  -width 800 -height 640
	wm resizable . 1 1
	wbCreateWidgets
}

wbMain


