#!/bin/sh
#TkWhiteBoardText.tcl
# \
exec wish "$0" ${1+"$@"}
#!/usr/local/bin/wish
# the next line restarts using wish\
#exec wish "$0" "$@" 
#####################CLONE TEXTE de:##########################
#
#   TkWhiteboard : a simple network whiteboard completely cross-plateform.
#   version 0.2
#
#   author : Jean-Yves Chasle
#   Copyright (C) Jean-Yves Chasle 2001-2002
#   mail : jeanyves.chasle@free.fr
#
#   TkWhiteboard is distributed under the GNU General Public Licence.
#   TkWhiteboard comes with ABSOLUTELY NO WARRANTY or GUARANTEE OF FITNESS
#   FOR A PARTICULAR PURPOSE.  See the file COPYING for complete
#   information.
#
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jlsendral@free.fr
#  Date    : 27/11/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean-Louis Sendral. 
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *************************************************************************
#
#----------------------------------------------------------------------------------------------------------
# wbInitialization (must be called after wbCreateWidgets)
#----------------------------------------------------------------------------------------------------------

# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [gettext hello]
# ou bien : puts stdout [gettext hello]
# #########################################################################
proc gettext { m } {
  global LG i18n
  if { [info exists i18n($LG,$m)] } {
    return $i18n($LG,$m)
  } elseif { [info exists i18n(fr,$m)] } {
    return $i18n(fr,$m)
  } else {
    return "err.i18n_$LG : \"$m\" needed."
  }
} ;# proc gettext
source tkwhiteboardtext.conf
global DOSSIER_TEXTES
if { $tcl_platform(platform) == "UNIX" } { 
set DOSSIER_TEXTES $env(HOME)
} else {
set DOSSIER_TEXTES [pwd]
}
source i18n


proc wbInitialization { } {
	global wb fbcpt

	set wb(generalinfo) [gettext general_info]
	set wb(servip)	127.0.0.1	;# Default server ip address.
	set wb(servport)	33000		;# Default server port.
	set wb(servpass)	""		;# No default password.
	set wb(timeout)	30000		;# Equivalent to 30 seconds.

	# Server and client messages.
	set wb(msg_askpasswd)	[gettext Server_waiting_for_password]
	set wb(msg_serverok)	[gettext Server_OK_waiting_for_commands]
	set wb(msg_clientok)	[gettext Client_OK_for_feedback]
	set wb(msg_fbcompleted)	[gettext Feedback_completed]

	# Connection status messages.
	set wb(status_disconnected)			[gettext disconnected]
	set wb(status_connectioninprogress)		[gettext connection_in_progress]
	set wb(status_authenticationinprogress)	[gettext authentication_in_progress]
	set wb(status_feedbackinprogress)		[gettext feedback_in_progress]
	set wb(status_initsessioncompleted)		[gettext init_session_completed]

	# Connection variables.
	set wb(mysock) ""
	set wb(connected) 0
	set wb(insession) 0
	set wb(connectionstatus) $wb(status_disconnected)
	set wb(servsock) ""
	set wb(servrunning) 0
	set fbcpt -1	;# Feedback counter (number of the last canvas object).

	# Gid variables.
	wbSetPenStyle "free"
	wbSetPenColor black
	wbSetPenWidth 1
	set wb(button-down) 0
	set wb(colorenable)	black
	set wb(colordisable)	grey50
	set wb(colorhilight)	red
}



#----------------------------------------------------------------------------------------------------------
# wbCreateWidgets
#----------------------------------------------------------------------------------------------------------
proc wbCreateWidgets { } {
	global wb
	# Initialize button images
	set wb(curdir) [pwd]
	image create photo wb(img_free)	-file [file join $wb(curdir) images "open_file1.gif"]
	image create photo wb(img_line)	-file [file join $wb(curdir) images "save_file1.gif"]
	image create photo wb(img_arrow)	-file [file join $wb(curdir) images "centre.gif"]
#	image create photo wb(img_rectempt)	-file [file join $wb(curdir) images "rect.gif"]
#	image create photo wb(img_rectfill)	-file [file join $wb(curdir) images "rectfill.gif"]
#	image create photo wb(img_elpsempt)	-file [file join $wb(curdir) images "ellipse.gif"]
#	image create photo wb(img_elpsfill)	-file [file join $wb(curdir) images "ellipfill.gif"]
	image create photo wb(img_wid1)	-file [file join $wb(curdir) images "souligne.gif"]
	image create photo wb(img_wid2)	-file [file join $wb(curdir) images "centre.gif"]
	image create photo wb(img_wid4)	-file [file join $wb(curdir) images "desouligne.gif"]
	image create photo wb(img_wid8)	-file [file join $wb(curdir) images "decentre.gif"]
	image create photo wb(img_wid16)	-file [file join $wb(curdir) images "hel20.gif"]
	image create photo wb(img_wid32)	-file [file join $wb(curdir) images "hel8.gif"]
	image create photo wb(img_wid64)	-file [file join $wb(curdir) images "hel14.gif"]
	image create photo wb(img_wid128)	-file [file join $wb(curdir) images "efftag.gif"]
	image create photo wb(img_wid256)	-file [file join $wb(curdir) images "efftout.gif"]



	# Frames
	frame .fu -bd 2 -relief groove
	frame .fl -bd 2 -relief groove
	frame .fr -bd 2 -relief groove
	frame .fd -bd 2 -relief groove

	grid .fu -row 0 -column 0 -columnspan 2 -sticky ew
	grid .fl -row 1 -column 0 -sticky ns
	grid .fr -row 1 -column 1 -sticky news
	grid .fd -row 2 -column 0 -columnspan 2 -sticky ew

	grid rowconfigure . 0 -weight 0
	grid rowconfigure . 1 -weight 1
	grid rowconfigure . 2 -weight 0
	grid columnconfigure . 0 -weight 0
	grid columnconfigure . 1 -weight 1

	# Inside upper frame
	set wb(btn_client,w) [button .fu.b1 -text [gettext connect_to_server] -width 20 -command {if $wb(connected) wbCloseClient else wbOpenClient}]
	set wb(btn_server,w) [button .fu.b2 -text [gettext create_server] -width 20 -command {if $wb(servrunning) wbCloseServer else wbOpenServer}]
	set wb(lbl_ip,w) [label .fu.l1 -text [gettext server]]
	set wb(ent_ip,w) [entry .fu.e1 -textvariable wb(servip) -width 15 -relief sunken]
	set wb(lbl_port,w) [label .fu.l2 -text [gettext port] -fg black]
	set wb(ent_port,w) [entry .fu.e2 -textvariable wb(servport) -width 5 -relief sunken]
	set wb(lbl_pass,w) [label .fu.l3 -text [gettext password]]
	set wb(ent_pass,w) [entry .fu.e3 -textvariable wb(servpass) -width 8 -show "*" -relief sunken]
	set wb(btn_quit,w) [button .fu.b3 -text [gettext quit] -command "exit"]

	grid 	$wb(btn_client,w) \
		$wb(btn_server,w) \
		$wb(lbl_ip,w) \
		$wb(ent_ip,w) \
		$wb(lbl_port,w) \
		$wb(ent_port,w) \
		$wb(lbl_pass,w) \
		$wb(ent_pass,w) \
		$wb(btn_quit,w)

	# Inside left frame
		# Sub-frames
		frame .fl.sf1 -bd 2 -relief groove
		frame .fl.sf2 -bd 2 -relief groove
		frame .fl.sf3 -bd 2 -relief groove
		frame .fl.sf4 -bd 2 -relief groove
		frame .fl.sf5 -bd 2 -relief groove

		pack .fl.sf1 .fl.sf2 .fl.sf3 .fl.sf4 .fl.sf5 -side top -padx 2 -pady 2

		# Sub_frame "pen style" : buttons
		set wb(chk_free,w) [checkbutton .fl.sf1.b00 -image wb(img_free) -indicatoron 0 -variable wb(chk_free,s) -command { charger  } ]
		set wb(chk_line,w) [checkbutton .fl.sf1.b10 -image wb(img_line) -indicatoron 0 -variable wb(chk_line,s) -command {sauver  } ]
		set wb(chk_arrow,w) [checkbutton .fl.sf1.b11 -image wb(img_arrow) -indicatoron 0 -variable wb(chk_arrow,s) -command {set index [ .fr.text index insert] ; centrer_ligne  $index ; \
wbSendOwnCmd [list .fr.text tag configure tag_ligne -justify center ] ; wbSendOwnCmd [list centrer_ligne $index ] } ]
#		set wb(chk_rectempt,w) [checkbutton .fl.sf1.b20 -image wb(img_rectempt) -indicatoron 0 -variable wb(chk_rectempt,s) -command {wbSetPenStyle "rectempt"}]
#		set wb(chk_rectfill,w) [checkbutton .fl.sf1.b21 -image wb(img_rectfill) -indicatoron 0 -variable wb(chk_rectfill,s) -command {wbSetPenStyle "rectfill"}]
#		set wb(chk_elpsempt,w) [checkbutton .fl.sf1.b30 -image wb(img_elpsempt) -indicatoron 0 -variable wb(chk_elpsempt,s) -command {wbSetPenStyle "elpsempt"}]
#		set wb(chk_elpsfill,w) [checkbutton .fl.sf1.b31 -image wb(img_elpsfill) -indicatoron 0 -variable wb(chk_elpsfill,s) -command {wbSetPenStyle "elpsfill"}]

		grid $wb(chk_free,w)
		grid $wb(chk_line,w) 
 #          grid $wb(chk_arrow,w)
#		grid $wb(chk_rectempt,w) $wb(chk_rectfill,w)
#		grid $wb(chk_elpsempt,w) $wb(chk_elpsfill,w)

		# Sub_frame "pen color" : button
		set wb(btn_color,w) [button .fl.sf2.b0 -bg red -width 4 -command {wbSetPenColor ; set Bon_Tag $wb(curcolor) ; \
 .fr.text tag configure $Bon_Tag -foreground $Bon_Tag } ]
global index_mot ; set index_mot 0
		pack $wb(btn_color,w) -fill both -expand yes -ipadx 2 -ipady 2           
		# Sub_frame "pen width" : buttons
		set wb(chk_wid1,w) [checkbutton .fl.sf3.b00 -image wb(img_wid1) -indicatoron 0 -variable wb(chk_wid1,s) -command {set ind [test_fin_ligne  [.fr.text index insert] ] ; if { $ind != "1.0" } { \
set mot [.fr.text get "$ind wordstart" "$ind wordend" ] ; .fr.text  tag configure "tag${mot}_s" -underline yes  ; \
   .fr.text tag add "tag${mot}_s"  "$ind wordstart" "$ind wordend" ; wbSendOwnCmd [list .fr.text tag configure "tag${mot}_s"    -underline yes ] ; wbSendOwnCmd [concat [list .fr.text tag add "tag${mot}_s"    ] \"$ind wordstart\" \"$ind wordend\" ] }} ]
		set wb(chk_wid2,w) [checkbutton .fl.sf3.b01 -image wb(img_wid2) -indicatoron 0 -variable wb(chk_wid2,s) -command { set ind [ .fr.text index insert] ; set ligne [.fr.text get "$ind linestart" "$ind lineend" ] ; .fr.text tag configure "tag${ligne}_c" -justify center ; \
  .fr.text tag add "tag${ligne}_c"  "$ind linestart" "$ind lineend" ; wbSendOwnCmd [list .fr.text tag configure "tag${ligne}_c"  -justify center ] ; wbSendOwnCmd [concat [list .fr.text tag add "tag${ligne}_c"  ] \"$ind linestart\" \"$ind lineend\" ] } ]
		set wb(chk_wid4,w) [checkbutton .fl.sf3.b10 -image wb(img_wid4) -indicatoron 0 -variable wb(chk_wid4,s) -command {set ind [test_fin_ligne [ .fr.text index insert] ] ; if { $ind != "1.0" } {  
set mot [.fr.text get "$ind wordstart" "$ind wordend" ] ; .fr.text tag configure "tag${mot}_s" -underline no ; \
  set ind [ .fr.text index insert] ; 
 .fr.text tag add "tag${mot}_s"  "$ind wordstart" "$ind wordend" ; wbSendOwnCmd [list .fr.text tag configure "tag${mot}_s"   -underline no ] ; wbSendOwnCmd [concat [list .fr.text tag add  "tag${mot}_s"  ] \"$ind wordstart\" \"$ind wordend\" ] }} ]
		set wb(chk_wid8,w) [checkbutton .fl.sf3.b11 -image wb(img_wid8) -indicatoron 0 -variable wb(chk_wid8,s) -command { set ind [ .fr.text index insert] ;  set ligne [.fr.text get  "$ind linestart" "$ind lineend"]  ; .fr.text tag configure "tag${ligne}_c"   -justify left ; \
 .fr.text tag add "tag${ligne}_c"  "$ind linestart" "$ind lineend" ; wbSendOwnCmd [list .fr.text tag configure "tag${ligne}_c"  -justify left ] ; wbSendOwnCmd [concat [list .fr.text tag add "tag${ligne}_c"   ] \"$ind linestart\" \"$ind lineend\" ] } ]

set wb(chk_wid16,w) [checkbutton .fl.sf3.b12 -image wb(img_wid16) -indicatoron 0 -variable wb(chk_wid16,s) -command { set ind [ test_fin_ligne [ .fr.text index insert]] ; if { $ind != "1.0" } { 
set mot [.fr.text get "$ind wordstart" "$ind wordend" ] ; .fr.text  tag configure "tag${mot}_s" -font {Helvetica 20 bold}  ; .fr.text  tag add "tag${mot}_s"  "$ind wordstart" "$ind wordend" ; \
wbSendOwnCmd [concat [list .fr.text tag configure "tag${mot}_s"    ] -font \{Helvetica 20 bold\} ] ;  wbSendOwnCmd [concat [list .fr.text tag add "tag${mot}_s"   ] \"$ind wordstart\" \"$ind wordend\" ]  }} ]

set wb(chk_wid32,w) [checkbutton .fl.sf3.b13 -image wb(img_wid32) -indicatoron 0 -variable wb(chk_wid32,s) -command { set ind [ test_fin_ligne [.fr.text index insert]]  ; if { $ind != "1.0" } { 
 set mot [.fr.text get "$ind wordstart" "$ind wordend" ] ; .fr.text  tag configure "tag${mot}_s" -font {Helvetica 8 bold}  ; .fr.text  tag add "tag${mot}_s"  "$ind wordstart" "$ind wordend"  ;  \
wbSendOwnCmd [concat [list .fr.text tag configure "tag${mot}_s"    ] -font \{Helvetica 8 bold\} ] ;  wbSendOwnCmd [concat [list .fr.text tag add "tag${mot}_s"   ] \"$ind wordstart\" \"$ind wordend\" ]  }} ]

set wb(chk_wid64,w) [checkbutton .fl.sf3.b14 -image wb(img_wid64) -indicatoron 0 -variable wb(chk_wid64,s) -command { set ind [ test_fin_ligne [.fr.text index insert]]  ; if { $ind != "1.0" } { 
set mot [.fr.text get "$ind wordstart" "$ind wordend" ] ; .fr.text  tag configure "tag${mot}_s" -font {Helvetica 14 bold}  ; .fr.text  tag add "tag${mot}_s"  "$ind wordstart" "$ind wordend"  ;  \
wbSendOwnCmd [concat [list .fr.text tag configure "tag${mot}_s"    ] -font \{Helvetica 14 bold\} ] ;  wbSendOwnCmd [concat [list .fr.text tag add "tag${mot}_s"   ] \"$ind wordstart\" \"$ind wordend\" ]  }} ]


set wb(chk_wid128,w) [button .fl.sf4.eftag -image wb(img_wid128)  \
-command   {set l_tag [ $wb(canvas,w) tag names] ; foreach tg $l_tag { \
 $wb(canvas,w) tag remove $tg 0.1 end ; wbSendOwnCmd [list .fr.text tag remove $tg 0.1 end ] } }]
set wb(chk_wid256,w) [button .fl.sf4.eftout -image wb(img_wid256) -command \
{$wb(canvas,w) delete 1.0 end ; wbSendOwnCmd [list .fr.text delete 1.0 end] }]		


set aide [button .fl.sf5.aide  -text Aide -command {exec wish aide_t.tcl }]
grid $wb(chk_wid1,w) $wb(chk_wid2,w)
		grid $wb(chk_wid4,w) $wb(chk_wid8,w)
		grid $wb(chk_wid16,w) $wb(chk_wid32,w)
		grid $wb(chk_wid64,w)  
    grid $wb(chk_wid256,w) 
       grid $wb(chk_wid128,w) 
#$aide
grid $aide 

	# Inside right frame
	set wb(canvas,w) [text .fr.text -wrap none -bg white -font {Helvetica 14 bold } -foreground {green4}]
global Color_Text ; set Color_Text green ; global Bon_Tag ; set Bon_Tag Bon_Tag1 ; .fr.text tag configure Bon_Tag1 -foreground red 
       
   bind $wb(canvas,w) <KeyPress> {set ind [ .fr.text index insert] ;wbSendOwnCmd [list .fr.text insert $ind %A ]}
   # InsertChar .fr.text $ind "%K" 
       bind $wb(canvas,w) <Return> {set ind [ .fr.text index insert] ; wbSendOwnCmd [concat [list .fr.text insert $ind]  \\n] }
       bind $wb(canvas,w) <space> {set ind [ .fr.text index insert] ;wbSendOwnCmd [list .fr.text insert $ind " " ] }
focus -force $wb(canvas,w)
#bind $wb(canvas,w)  <Insert> {set ind [ .fr.text index insert] ; set sel [.fr.text get 0.1 end] ; .fr.text insert $ind "\n" }
  bind $wb(canvas,w) <BackSpace> {set ind [ .fr.text index insert] ; set lind [split $ind  "."] ; set prem [lindex $lind 0] ; set deux [expr [lindex $lind 1] - 1] ; \
if {[expr [lindex $lind 1] == 0 ]} {
set prem [expr [lindex $lind 0] - 1] ; set ind2 "${prem}.0"
set deux  [.fr.text index "$ind2 lineend"] ; set trois [.fr.text index "$deux +1 chars" ] ; \
 wbSendOwnCmd [list .fr.text delete $deux $trois ] 
} else { ; \
set ind1 "${prem}.${deux}" ; wbSendOwnCmd [list .fr.text delete $ind1 $ind ] } }
   bind $wb(canvas,w) <Delete> {set ind [.fr.text index insert] ; set lind [split $ind  "."] ; set prem [lindex $lind 0] ; set deux [expr [lindex $lind 1] + 1] ; \
if { $ind == [.fr.text index "$ind lineend"]} {
set ind_f [.fr.text index "$ind +1 chars" ]
#set ind_b [.fr.text index "$ind +1 lines"]
#set ligne [.fr.text get [.fr.text index "$ind_b linestart"] [.fr.text index "$ind_b lineend"]]
#set ind_f [ .fr.text index "$ind_t lineend"]
wbSendOwnCmd [list .fr.text delete  $ind $ind_f] 
#wbSendOwnCmd [list .fr.text delete [.fr.text index "$ind_b linestart"] 
#[.fr.text index "$ind_b lineend"]] 
} else {
set ind1 "${prem}.${deux}" ; wbSendOwnCmd [list .fr.text delete $ind  $ind1 ] } }
#     bind $wb(canvas,w) <Key-Up> {}
#        bind $wb(canvas,w) <Key-Down> {}
#       bind $wb(canvas,w) <Key-Right> {}
#       bind $wb(canvas,w) <Key-Left> {}
        bind $wb(canvas,w) <Control-c> { tk_textCopy .fr.text ; wbSendOwnCmd [list tk_textCopy .fr.text ] }
        bind $wb(canvas,w) <Control-v> { tk_textPaste .fr.text ; wbSendOwnCmd [list tk_textPaste .fr.text ] }
#	bind $wb(canvas,w) <Button-1> {button-down %x %y}
	bind $wb(canvas,w) <Double-ButtonRelease-1> {  $wb(canvas,w) tag add $Bon_Tag sel.first sel.last  ; set index1 [.fr.text index sel.first] ; set index2 [.fr.text index sel.last] ; \
 ; set coul $wb(curcolor) ; wbSendOwnCmd [list  $wb(canvas,w) tag  configure $Bon_Tag  -foreground $coul ]  ; \
 wbSendOwnCmd [list $wb(canvas,w) tag add $Bon_Tag $index1 $index2 ] ; \
}
##$wb(canvas,w) tag  configure tag1 -background red ;
#	bind $wb(canvas,w) <B1-Motion> {button-motion %x %y}
#	bind $wb(canvas,w) <ButtonRelease-1> {button-release %x %y}

	pack $wb(canvas,w) -fill both -expand yes

	# Inside lower frame
	set wb(lbl_geninfo,w) [label .fd.l1 -textvariable wb(generalinfo) -fg black]
	pack $wb(lbl_geninfo,w) -fill both -expand yes

	wbInitialization
}

proc test_fin_ligne { index } {
set ind   [.fr.text index end ] ; set abs [expr int($ind) ]
set ind1 [.fr.text index "$index lineend"]
 if { $index == [.fr.text index "$index lineend" ] } {
set ind3 [ .fr.text index "$index -2 chars" ]
  if { $index == [.fr.text index "$index linestart"] } {
   set ind_p [ .fr.text index end]
   return "1.0"
   ## [ .fr.text index "$ind_p -1 chars"] }
   #"1.0"
 return [ .fr.text index "$index -2 chars" ]
   }
#if { [expr int($index)] == [expr int([ .fr.text index end ]) - 1] } {
#       return "1.0"
#}
return $index
}
 #  return [$index linestart]
#[$index { lineend - 2 chars }]
#} else 

proc InsertChar {w lieu char } {
#    if {[ lsearch {Right Left Up Down Insert Escape Meta Tab Alt_L Control_L Shift_L Num_Lock Caps_Lock } $char] != -1}  {
#    return
#    } 
if {[expr [regexp {[[:alnum:]_]} $char ] && [expr [string length $char] == 1]]}  {
               wbSendOwnCmd [list $w insert $lieu $char ] ; return
         }
switch  $char {
		eacute {
			wbSendOwnCmd [list $w insert $lieu  ] ; return
       		  }
		egrave {
			wbSendOwnCmd [list $w insert $lieu  ] ; return
       		  }

         		  agrave {
			wbSendOwnCmd [list $w insert $lieu  ] ; return
       		  }
		ccedilla {
			wbSendOwnCmd [list $w insert $lieu  ] ; return
       		  }
  	        ugrave {
			wbSendOwnCmd [list $w insert $lieu  ] ; return
       		  }
		percent {
			wbSendOwnCmd [list $w insert $lieu % ] ; return
       		  }

 		asterisk {
			wbSendOwnCmd [list $w insert $lieu * ] ; return
       		  }
		slash {
			wbSendOwnCmd [list $w insert $lieu / ] ; return
       		  }
		minus {
			wbSendOwnCmd [list $w insert $lieu - ] ; return
       		  }
		plus {
			wbSendOwnCmd [list $w insert $lieu + ] ; return
       		  }

 		dollar {
			wbSendOwnCmd [list $w insert $lieu $ ] ; return
       		  }
		sterling {
			wbSendOwnCmd [list $w insert $lieu  ] ; return
       		  }
		comma {
			wbSendOwnCmd [list $w insert $lieu , ] ; return
       		  }
		equal {
			wbSendOwnCmd [list $w insert $lieu = ] ; return
       		  }

 		question {
			wbSendOwnCmd [list $w insert $lieu ? ] ; return
       		  }
		exclam {
			wbSendOwnCmd [list $w insert $lieu ! ] ; return
       		  }
		parenleft {
			wbSendOwnCmd [list $w insert $lieu ( ] ; return
       		  }
		parenright {
			wbSendOwnCmd [list $w insert $lieu ) ] ; return
       		  }

        		  comma {
			wbSendOwnCmd [list $w insert $lieu , ] ; return
       		  }
		colon {
			wbSendOwnCmd [list $w insert $lieu : ] ; return
       		  }

		underscore {
			wbSendOwnCmd [list $w insert $lieu _ ] ; return
       		  }
		semicolon {
			wbSendOwnCmd [list $w insert $lieu \; ] ; return
       		  }
		period {
			wbSendOwnCmd [list $w insert $lieu \. ] ; return
       		  }
	
}
#     if { [regexp {[^KP_]} $char]} {
#return
#}
 }



#switch -regexp $char  {
#    [a,b,c,d] {
#     wbSendOwnCmd [list $w insert $lieu $char ] ; return
#               }
#   [e,f,g,1] {
#     wbSendOwnCmd [list $w insert $lieu $char ] ; return
 #              }         
#b#ind $wb(canvas,w) <Alt-KeyPress> {# nothing}
# bind $wb(canvas,w) <Meta-KeyPress> {# nothing}
# bind $wb(canvas,w) <Control-KeyPress> {# nothing}
# bind $wb(canvas,w) <Escape> {# nothing}
# bind $wb(canvas,w) <KP_Enter> {# nothing}
# bind $wb(canvas,w) <Tab> {# nothing}

proc centrer_ligne { indice } {
global .text.fr
 .fr.text tag configure tag_ligne -justify center ; .fr.text tag add tag_ligne "$indice linestart" "$indice lineend" 
}

proc charger { } {
global texte  DOSSIER_TEXTES  ; set texte { }
 ;  cd  $DOSSIER_TEXTES 
set types {
    {"Catgories"		{.txt}	}
}
catch {set file [tk_getOpenFile -filetypes $types]}
if { [ catch { set f [open [file join $file] "r" ] } ] } {
set answer [tk_messageBox -message [gettext err_fich] -type ok -icon info]
exit
}
set index [.fr.text index insert ]
while {[gets $f ligne] >=0} {
 .fr.text insert $index "$ligne\n" 
wbSendOwnCmd [list .fr.text insert $index  $ligne] 
wbSendOwnCmd [concat [list .fr.text  insert "$index lineend"] \\n] 
set index [expr $index + 1]
}
close $f
}


proc sauver { } {
global wb    global DOSSIER_TEXTES 
cd $DOSSIER_TEXTES     
set types {
    {"Catgories"		{.txt}	}
}
catch {set file [tk_getSaveFile -filetypes $types]}
set f [open [file join $file] "a"]
set travail [$wb(canvas,w) get 1.0 end] 
puts $f $travail
##puts $f [ $wb(canvas,w) dump 0.1 end]
close $f
}

#----------------------------------------------------------------------------------------------------------
# wbSetPenStyle : proc linked to the "pen style" checkbuttons.
#----------------------------------------------------------------------------------------------------------
proc wbSetPenStyle { style } {
	global wb

	set chk_name [format "%s%s" "chk_" $style]
	set wb([format "%s%s%s" "chk_" $style ",s"]) 1
	set wb(curstyle) $style

	if {$style != "free"} {set wb(chk_free,s) 0}
	if {$style != "line"} {set wb(chk_line,s) 0}
	if {$style != "arrow"} {set wb(chk_arrow,s) 0}
	if {$style != "rectempt"} {set wb(chk_rectempt,s) 0}
	if {$style != "rectfill"} {set wb(chk_rectfill,s) 0}
	if {$style != "elpsempt"} {set wb(chk_elpsempt,s) 0}
	if {$style != "elpsfill"} {set wb(chk_elpsfill,s) 0}
}

#----------------------------------------------------------------------------------------------------------
# wbSetPenColor : proc linked to the "pen color" button.
#----------------------------------------------------------------------------------------------------------
proc wbSetPenColor { {color ""} } {
	global wb

	if {$color != ""} {
		set wb(curcolor) $color
		$wb(btn_color,w) config -bg $color
	} else {
		set color [tk_chooseColor -title [gettext choose_color] -parent . -initialcolor $wb(curcolor)]
		if [string compare $color ""] {
			set wb(curcolor) $color
			$wb(btn_color,w) config -bg $color
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbSetPenWidth : proc linked to the "pen width" checkbuttons.
#----------------------------------------------------------------------------------------------------------
proc wbSetPenWidth { width } {
	global wb

	set wb([format "%s%s%s" "chk_wid" $width ",s"]) 1
	set wb(curwidth) $width

	if {$width != 1} {set wb(chk_wid1,s) 0}
	if {$width != 2} {set wb(chk_wid2,s) 0}
	if {$width != 4} {set wb(chk_wid4,s) 0}
	if {$width != 8} {set wb(chk_wid8,s) 0}
}

#----------------------------------------------------------------------------------------------------------
# wbOpenServer : proc linked to the "create server" button.
#----------------------------------------------------------------------------------------------------------
proc wbOpenServer { } {
	global wb

	# Open the server socket.
	catch {close $wb(servsock)}
	if [catch {socket -server wbServerOpenNewClientSocket $wb(servport)} wb(servsock)] {
		set wb(generalinfo) "Server socket couldn't be attached to already used port $wb(servport)..."
	} else {
		set wb(servrunning) 1
		set wb(generalinfo) "[gettext Server_attached_to_port] $wb(servport).  [gettext Waiting_for_client ]..."

		$wb(btn_server,w) config -text [gettext close_server] -foreground $wb(colorhilight)
		$wb(btn_client,w) config -state disabled
		$wb(ent_ip,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_port,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_pass,w) config -state disabled -foreground $wb(colordisable)
	}
}

#----------------------------------------------------------------------------------------------------------
# wbServerOpenNewClientSocket : callback proc called by the listening system.
#----------------------------------------------------------------------------------------------------------
proc wbServerOpenNewClientSocket {sock ip port} {
	global wb guest

	# This function is called when the server receives a connection.
	set guest($sock) [list $wb(status_authenticationinprogress) $ip $port]
	set wb(connected) 1
#	fconfigure $sock -buffering line

	# "Receive character line from guest or client" callback.
	fileevent $sock readable [list wbServerReadGuestLineFromBuffer $sock]

	# Ask new guest for a password.
	puts $sock $wb(msg_askpasswd)
	flush $sock
	set wb(generalinfo) "[gettext guest] ([lindex $guest($sock) 1]) [gettext connect_to_server]"
}

#----------------------------------------------------------------------------------------------------------
# wbServerReadGuestLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbServerReadGuestLineFromBuffer { sock } {
	global wb guest client fb

	# Read a line when it's completely buffered.
	set numargs [gets $sock line]
 	if {$numargs == -1} {
		catch {close $sock}
		set wb(generalinfo) "[gettext guest] ([lindex $guest($sock) 1]) [gettext is_disconnected]"
		unset guest($sock)

		# Update $wb(connected) after deleting a guest socket.
		if {[array size guest] == 0 && [array size client] == 0} {
			set wb(connected) 0
		}

		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text [gettext connect_to_server] -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "[gettext Received ] $line."
		switch [lindex $guest($sock) 0] \
			$wb(status_authenticationinprogress) {
				if {$line == $wb(servpass)} {
					set guest($sock) [lreplace $guest($sock) 0 0 $wb(status_feedbackinprogress)]

					# Send "Ok" message to guest.
					puts $sock $wb(msg_serverok)
					flush $sock
					set wb(generalinfo) "A new client ([lindex $guest($sock) 0]) is about to join the open session. Sending feedback..."
				} else {
					# Disconnect guest : wrong password.
					catch {close $sock}
					set wb(generalinfo) "[gettext wrong_password] [gettext guest] ([lindex $guest($sock) 1]) [gettext disconnected_by_server]"
					unset guest($sock)

					# Update $wb(connected) after deleting a guest socket.
					if {[array size guest] == 0 && [array size client] == 0} {
						set wb(connected) 0
					}
				}
			} \
			$wb(status_feedbackinprogress) {
				if {$line == $wb(msg_clientok)} {
					# Send feedback to client.
					set cpt 0
					while {[info exists fb($cpt)]} {
						puts $sock $fb($cpt)
						flush $sock
						incr cpt
					}

					# Send "end of feedback" message to client.
					puts $sock $wb(msg_fbcompleted)
					flush $sock

					# Guest upgrades to client.
					set client($sock) [list [lindex $guest($sock) 1] [lindex $guest($sock) 2]]
					unset guest($sock)
					set wb(insession) 1

					# Change the "receive character line from client" callback.
					fileevent $sock readable [list wbServerReadClientLineFromBuffer $sock]
					set wb(generalinfo) "Client ([lindex $client($sock) 0]) [gettext is_now_participating]"
				}
			} \
			default {
				set wb(generalinfo) "[gettext Received] [gettext unknown_command] : \"$line\" !"
			}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbServerReadClientLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbServerReadClientLineFromBuffer { sock } {
	global wb guest client fbcpt fb

	# Read a line when it's completely buffered.
	set numargs [gets $sock line]
 	if {$numargs == -1} {
		catch {close $sock}
		set wb(generalinfo) "Client ([lindex $client($sock) 0]) [gettext is_disconnected]"
		unset client($sock)

		# Update and $wb(insession) after deleting a guest or client socket.
		if {[array size client] == 0} {
			set wb(insession) 0
			if {[array size guest] == 0} {
				set wb(connected) 0
			}
		}

		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text "[gettext Connect_to_server]" -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "[gettext Received] $line.";
		wbProcessReceivedCmd $line
		incr fbcpt 1
		set fb($fbcpt) $line
		wbDispatchReceivedCmd $sock $line
	}
}

#----------------------------------------------------------------------------------------------------------
# wbCloseServer : proc linked to the "create server" button.
#----------------------------------------------------------------------------------------------------------
proc wbCloseServer { } {
	global wb guest client

	# Close every socket stored in client array.
	set wb(generalinfo) "[gettext Closing_connections]..."
	foreach {sock} [array names guest] {
		fileevent $sock readable {}
		catch {close $sock}
		unset guest($sock)
	}
	foreach {sock} [array names client] {
		fileevent $sock readable {}
		catch {close $sock}
		unset client($sock)
	}
	set wb(connected) 0
	set wb(generalinfo) "[gettext Connection_closed]."

	# Close the server socket.
	catch {close $wb(servsock)}
	set wb(servrunning) 0
	set wb(generalinfo) [gettext Server_closed]
	$wb(btn_server,w) config -text "[gettext Create_server]" -foreground $wb(colorenable)
	$wb(btn_client,w) config -state normal
	$wb(ent_ip,w) config -state normal -foreground $wb(colorenable) 
	$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
	$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
}

#----------------------------------------------------------------------------------------------------------
# wbOpenClient : proc linked to the "connect to server" button.
#----------------------------------------------------------------------------------------------------------
proc wbOpenClient { } {
	global wb

	# Open the data socket.
	catch {close $wb(mysock)}
	set wb(connected) 0
	set wb(insession) 0
	set wb(connectionstatus) $wb(status_disconnected)
	if {[catch {socket -async $wb(servip) $wb(servport)} wb(mysock)]} {
		set wb(generalinfo) "[gettext No_socket] !"
		return
	}

	# "Receive character line from server" callback.
	fileevent $wb(mysock) readable wbGuestReadServerLineFromBuffer

	set wb(generalinfo) "Trying to connect to server $wb(servip) on port $wb(servport)."
	set wb(connectionstatus) $wb(status_connectioninprogress)
	$wb(btn_client,w) config -state disabled
	$wb(btn_server,w) config -state disabled
	$wb(ent_ip,w) config -state disabled -foreground $wb(colordisable)
	$wb(ent_port,w) config -state disabled -foreground $wb(colordisable)
	$wb(ent_pass,w) config -state disabled -foreground $wb(colordisable)

	# Waiting $timeout milliseconds before declaring that connection failed.
	set afterid [after $wb(timeout) {set wb(connected) 0}]
	vwait wb(connected) ;# Either modified by wbGuestReadLineFromBuffer or timeout.
	after cancel $afterid

	# Connection issue : it may be 1 (successfull) or 0 (timeout).
	if {$wb(connected)} {
		# This code is run after the msg_serverok is received in wbClientReadLineFromBuffer.
		$wb(btn_client,w) config -state normal -text [gettext close_connection] -foreground $wb(colorhilight)
		$wb(ent_ip,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_port,w) config -state disabled -foreground $wb(colordisable)
		$wb(ent_pass,w) config -state disabled -foreground $wb(colordisable)
	} else {
		# This code is run after the preceeding "after" command (timeout).
		catch {close $wb(mysock)}
		set wb(connectionstatus) $wb(status_disconnected)
		set wb(generalinfo) "Server $wb(servip) on port $wb(servport) not responding. Connection failed."
		$wb(btn_client,w) config -state normal
		$wb(btn_server,w) config -state normal
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	}
}

#----------------------------------------------------------------------------------------------------------
# wbGuestReadServerLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbGuestReadServerLineFromBuffer { } {
	global wb

	# Read a line when it's completely arrived.
	set numargs [gets $wb(mysock) line]
 	if {$numargs == -1} {
		catch {close $wb(mysock)}
		set wb(mysock) ""
		switch $wb(connectionstatus) \
			$wb(status_authenticationinprogress) {
				set wb(generalinfo) "Incorrect password. Disconnected by server."
			} \
			default {
				set wb(generalinfo) "Disconnected by server."
			}
		set wb(connected) 0
		set wb(insession) 0
		set wb(connectionstatus) $wb(status_disconnected)
		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text "Connect to server" -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "[string length $line] [string length $wb(msg_askpasswd)] \"$line\" !"
		switch $line \
			$wb(msg_askpasswd) {
				# Send the password to server.
				puts $wb(mysock) $wb(servpass)
				flush $wb(mysock)

				set wb(connected) 1
				set wb(generalinfo) "Connected to server. Sending password..."
				set wb(connectionstatus) $wb(status_authenticationinprogress) \
			} \
			$wb(msg_serverok) {
				# Change the "receive character line from server" callback.
				fileevent $wb(mysock) readable wbClientReadServerLineFromBuffer

				# Send "ok" message to server.
				puts $wb(mysock) $wb(msg_clientok)
				flush $wb(mysock)

				set wb(generalinfo) "Joining an open session. Waiting for feedback..."
				set wb(connectionstatus) wb(status_feedbackinprogress)
			} \
			default {
				set wb(generalinfo) "[gettext Received] [gettext unknown_command] : \"$line\" !"
			}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbClientReadServerLineFromBuffer : reads a single line from buffer linked to a socket.
#----------------------------------------------------------------------------------------------------------
proc wbClientReadServerLineFromBuffer { } {
	global wb

	# Read a line when it's completely arrived.
	set numargs [gets $wb(mysock) line]
 	if {$numargs == -1} {
		catch {close $wb(mysock)}
		set wb(mysock) ""
		set wb(generalinfo) "[gettext disconnected_by_server]"
		set wb(connected) 0
		set wb(insession) 0
		set wb(connectionstatus) $wb(status_disconnected)
		$wb(btn_server,w) config -state normal
		$wb(btn_client,w) config -text "Connect to server" -foreground $wb(colorenable)
		$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
		$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
	} else {
		set wb(generalinfo) "[gettext Received] $line.";
		if {$line == $wb(msg_fbcompleted)} {
			set wb(insession) 1
			set wb(connectionstatus) $wb(status_initsessioncompleted) 
			set wb(generalinfo) "[gettext Feedback_completed]"
		} else {
			wbProcessReceivedCmd $line
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbCloseClient : proc linked to the "connect to server" button.
#----------------------------------------------------------------------------------------------------------

proc wbCloseClient { } {
	global wb

	# Close the data socket.
	set wb(generalinfo) [gettext closing_connection]
	catch {close $wb(mysock)}
	set wb(mysock) ""
	set wb(generalinfo) "[gettext disconnected_from_server]"
	set wb(connected) 0
	set wb(insession) 0
	set wb(connectionstatus) $wb(status_disconnected)
	$wb(btn_server,w) config -state normal
	$wb(btn_client,w) config -text "Connect to server" -foreground $wb(colorenable)
	$wb(ent_ip,w) config -state normal -foreground $wb(colorenable)
	$wb(ent_port,w) config -state normal -foreground $wb(colorenable)
	$wb(ent_pass,w) config -state normal -foreground $wb(colorenable)
}

#----------------------------------------------------------------------------------------------------------
# wbSendOwnCmd : proc called from mouse callbacks button-move and button-release.
#----------------------------------------------------------------------------------------------------------
proc wbSendOwnCmd { cmd } {
	global wb client fbcpt fb

	if $wb(insession) {
		if $wb(servrunning) {
			# Server part.
			incr fbcpt 1
			set fb($fbcpt) $cmd

			foreach sock [array names client] {
				puts $sock $cmd
				flush $sock
			}
		} else {
			# Client part.
			puts $wb(mysock) $cmd
			flush $wb(mysock)
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbDispatchReceivedCmd : proc called by wbServerReadlLineFromBuffer.
#----------------------------------------------------------------------------------------------------------
proc wbDispatchReceivedCmd { sendersock cmd } {
	global wb client

	if {$wb(servrunning) && $wb(insession)} {
		foreach sock [array names client] {
			if {$sendersock == $sock} {continue}
			puts $sock $cmd
			flush $sock
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbProcessReceivedCmd : proc called from wbServerReadLineFromBuffer and wbClientReadLineFromBuffer .
#----------------------------------------------------------------------------------------------------------
proc wbProcessReceivedCmd { cmd } {
	global wb

	set style free
# [lindex $cmd 0]
	switch $style {
		free	 { eval $cmd  }
		line		{$wb(canvas,w) create line		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6]}
		arrow		{$wb(canvas,w) create line		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6] -arrow last}
		rectempt	{$wb(canvas,w) create rectangle	[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -outline [lindex $cmd 6]}
		rectfill	{$wb(canvas,w) create rectangle	[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6]}
		elpsempt	{$wb(canvas,w) create arc		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -outline [lindex $cmd 6] -start 0 -extent 359 -style arc}
		elpsfill	{$wb(canvas,w) create arc		[lindex $cmd 1] [lindex $cmd 2] [lindex $cmd 3] [lindex $cmd 4] -width [lindex $cmd 5] -fill [lindex $cmd 6] -start 0 -extent 359 -style chord}
		default	{set wb(generalinfo) "[gettext Received] [gettext unknown_command] : \"$cmd\""} 
	}
}

#----------------------------------------------------------------------------------------------------------
# button-down : mouse callback linked to the canvas.
#----------------------------------------------------------------------------------------------------------
proc button-down { sx sy } {
	global wb

	if $wb(insession) {
		set wb(button-down) 1
		switch $wb(curstyle) {
			free -
			line {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create line $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor)]
			}
			arrow {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create line $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor) -arrow last]
			}
			rectempt {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create rectangle $sx $sy $sx $sy -width $wb(curwidth) -outline $wb(curcolor)]
			}
			rectfill {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create rectangle $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor)]
			}
			elpsempt {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create arc $sx $sy $sx $sy -width $wb(curwidth) -outline $wb(curcolor) -start 0 -extent 359 -style arc]
			}
			elpsfill {
				set wb(lastx) $sx
				set wb(lasty) $sy
				set wb(lastobj,w) [$wb(canvas,w) create arc $sx $sy $sx $sy -width $wb(curwidth) -fill $wb(curcolor) -start 0 -extent 359 -style chord]
			}
			default {
				set wb(generalinfo) "Unknown pen style \"$wb(curstyle)\"..."
			}
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# button-motion : mouse callback linked to the canvas.
#----------------------------------------------------------------------------------------------------------
proc button-motion { nx ny } {
	global wb

	if {$wb(insession) && $wb(button-down)} {
		switch $wb(curstyle) {
			free {
				$wb(canvas,w) create line $wb(lastx) $wb(lasty) $nx $ny -width $wb(curwidth) -fill $wb(curcolor)
				wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty) $nx $ny $wb(curwidth) $wb(curcolor)]
				set wb(lastx) $nx
				set wb(lasty) $ny
			}
			line -
			arrow -
			rectempt -
			rectfill -
			elpsempt -
			elpsfill {
				$wb(canvas,w) coords $wb(lastobj,w) $wb(lastx) $wb(lasty) $nx $ny
			}
			default {
				set wb(generalinfo) "Unknown pen style \"$wb(curstyle)\"..."
			}
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# button-release : mouse callback linked to the canvas.
#----------------------------------------------------------------------------------------------------------
proc button-release { nx ny } {
	global wb

	if {$wb(insession) && $wb(button-down)} {
		set $wb(button-down) 0
		switch $wb(curstyle) {
			free {}
			line -
			arrow -
			rectempt -
			rectfill -
			elpsempt -
			elpsfill {
				wbSendOwnCmd [list $wb(curstyle) $wb(lastx) $wb(lasty) $nx $ny $wb(curwidth) $wb(curcolor)]
			}
			default {
				set wb(generalinfo) "Unknown pen style \"$wb(curstyle)\"..."
			}
		}
	}
}

#----------------------------------------------------------------------------------------------------------
# wbMain : main proc.
#----------------------------------------------------------------------------------------------------------
proc wbMain { } {
	wm minsize . 30 5
	wm title . "TkWhiteboardText 0.2 (under GPL)"

	wbCreateWidgets
}

wbMain
















